/*
The contents of this file are subject to the Mozilla Public
License Version 1.1 (the "License"); you may not use this file
except in compliance with the License. You may obtain a copy of
the License at http://www.mozilla.org/MPL/

Software distributed under the License is distributed on an "AS
IS" basis, WITHOUT WARRANTY OF ANY KIND, either express or
implied. See the License for the specific language governing
rights and limitations under the License.

Alternatively, the contents of this file may be used under the
terms of the GNU General Public License Version 2 or later (the
"GPL"), in which case the provisions of the GPL are applicable 
instead of those above. 

Copyright (C) 2003
Vasa Maximov
mcv@mozdev.org
vmaximov@strana.ru
*/

var helpstr = "In general, this plugin operates on the parameters of the webpage you are curriently browsing and predefined parameters in ConQuery Config Dialog. When you execute ConQuery menu entry, the engine substitutes user variables in predefined URL template with corresponding page data. Available variables are: \n [:selection] - selected text;\n [:url] - page URL;\n [:host] - only HOST from page URL;\n [:prompt] - prompt for input text.\n You may combine variables in template. If there is [:selection] and no selected text on a page, the ConQuery will ask you to input one.\n    All queries organized in two groups: \n - list in ''ConQuery Config'' dialog under the My ConQueries tab;\n - entries under the ''Query to...'' context menu item.\n You may execute queries from bouth places. All manipulations with entries in Config menu performs with mouse right-click. The property ''Show?'' indicates whether query is shown in context menu group.\n The Config Dialog is also accessible via doubleclick on ''Query to...'' context menu entry.\n Note that this is alpha version, so any suggestions will be appreciated.\n Happy serfing!\n McV.";
var EntryList;
var EntryDesc;
var repEntryList;
var LastWill = "";
var delim = "\\";

var ProtoHash = {
  _Add: function(eId, Title, URL, Method, Desc, Context) {
      var tmp = {
          eId: '',
          Title: '',
          URL: '',
          Method: '',
          Desc: '',
          Context: false,
          clone : function(){
            var tO = new Object();
            for (var tP in this){tO[tP]=this[tP]}
            return tO;
          }
        }
			var i = 0;
    	while(!eId){
    		if (!this[i]){eId = i}
    		i++;
    	}
    	if (!Method) Method = "GET";
    	if (Context=="") Context = false;
      tmp["eId"] = eId;
      tmp["Title"] = Title;
      tmp["URL"] = URL;
      tmp["Method"] = Method.toUpperCase();
      tmp["Desc"] = Desc;
      tmp["Context"] = Context;
      this[eId] = tmp.clone();
      tmp = null;
  },
  _Exist: function(KeyName){
    var exst=false;
    if (this[KeyName]) exst=true; 
    return exst;
  },
  _Item: function(KeyName) {
      return(this[KeyName]);
  },
  _Rm: function (Key) {
    delete this[Key];
  },
  _Items: function(){
    //Getting items which not a "_Method"
    var items = [];
    var i = 0;
    var item;
      for (item in this){
        if (item.substr(0,1) != "_"){
          items[i] = this[item];
          i++;
          }
        }
    items.sort(this._Cmp);
    return items;
  },
  _Cmp: function(a, b){
    if (a.Title.toLowerCase() > b.Title.toLowerCase()){return 1;}
    else if (a.Title.toLowerCase() < b.Title.toLowerCase()) {return -1;}
    else {return 0;}
  },
  _Clear: function(){
    var item;
    for (item in this){
      if (item.substr(0,1) != "_"){
  			delete this[item];
      }
    }
  },
  _Clone: function(){
    var ObjSrc = new Object();
    for (var ObjProp in this){ObjSrc[ObjProp]=this[ObjProp]}
    return ObjSrc;
  }
}

//Active Entries holder
var EntryHash = ProtoHash._Clone();
//Repository Entries holder
var repEntryHash = ProtoHash._Clone();

var Prefs = Components.classes["@mozilla.org/preferences-service;1"].
  getService(Components.interfaces.nsIPrefService).getBranch("conquery.");

function init(){
  EntryList    = document.getElementById('EntryList');
  EntryDesc    = document.getElementById('Desc');
  repEntryList = document.getElementById('repEntryList');
	repEntryDesc = document.getElementById('repDesc');
	PlugsDirBox  = document.getElementById('plugsdir');
	ReadOnlyCqr  = document.getElementById('cqonly');
	PlugsDirBox.value = GetMycroftDir();
	document.getElementById('help').value = helpstr;
	FetchPrefs(EntryHash, "Entries.");
	window.setTimeout('initWithDelay();', 0);
  //window.sizeToContent();
}

function initWithDelay(){
  initList(EntryList, EntryHash);
}

function initList(list, srcHash){
  while (list.hasChildNodes()) {list.removeChild(list.lastChild)}
  var ondk;
  var onsel;
  var item;
  var node;
  var celldata;
  var cellcheck;
  var entries = srcHash._Items();

  var listcols =  document.createElement('listcols');
  var listcol1 =  document.createElement('listcol');
  var listcol2 =  document.createElement('listcol');
  var splitter = document.createElement('splitter');
  var listhead = document.createElement('listhead');
  var listheader1 =  document.createElement('listheader');
  var listheader2 =  document.createElement('listheader');
  splitter.setAttribute("class", "tree-splitter");
  listcol1.setAttribute("flex", "16");
  listcol2.setAttribute("flex", "1");
  listcol2.setAttribute("style", "width: 4em;");
  listcols.appendChild(listcol1);
    if (srcHash == EntryHash){
      listcols.appendChild(splitter);
      listcols.appendChild(listcol2);
    }
  listheader1.setAttribute('label', "Queries");
  listheader2.setAttribute('label', "Show?");
  listhead.appendChild(listheader1);
    if (srcHash == EntryHash){
      listhead.appendChild(listheader2);
    }
  list.appendChild(listcols);
  list.appendChild(listhead);
  
  for (i=0; i<entries.length; i++){
			  if (list.id == "EntryList"){
			  	ondk  = 'if (isValidLeftClick(event,"listitem")) ExecQuery("'+entries[i].eId+'");';
			  	onsel = 'onSelect(EntryHash, EntryDesc, '+entries[i].eId+')'
			  } else if(list.id == "repEntryList"){
			  	ondk='if (isValidLeftClick(event,"listcell")) CopyEntry(repEntryHash, '+entries[i].eId+', EntryHash, EntryList);';
			  	onsel = 'onSelect(repEntryHash, repEntryDesc, '+entries[i].eId+')';
			  }

    item = document.createElement('listitem');
    item.setAttribute('value', entries[i].eId);
    item.setAttribute('allowevents', true);
		//item.setAttribute('ondblclick', ondk);
		
    celldata = document.createElement('listcell');
    celldata.setAttribute('label', entries[i].Title);
    celldata.setAttribute('ondblclick', ondk);
    item.appendChild(celldata);
    if (srcHash == EntryHash){
      cellcheck = document.createElement('listcell');
      check = document.createElement('checkbox');
      check.setAttribute('id', entries[i].eId);
      check.setAttribute('oncommand', "UpdateStatus(this);");
      check.setAttribute('checked', entries[i].Context);
      cellcheck.appendChild(check);
      item.appendChild(cellcheck);
    }
    list.appendChild(item);
  }
}

function FetchPrefs(trgHash, group){
  trgHash._Clear();
  var entries = new Object;
  var prfs = Prefs.getChildList(group, {value: 0});
    for (p in prfs){
      tmp = prfs[p].split(".");
      entries[tmp[1]] = "";
    }
  for (entry in entries){
    trgHash._Add(
      ReadPref(group+entry+".eId"),
      ReadPref(group+entry+".Title"),
      ReadPref(group+entry+".URL"),
      ReadPref(group+entry+".Method"),
		  ReadPref(group+entry+".Desc"),
		  ReadPref(group+entry+".Context")
    )
  }
}

//////////////////////////////////////////////////////
////////SECTION: Predefined queries tab //////////////

function LoadRepository(src){
  if (!src) src = document.getElementById('repsrc').label;
	repEntryHash._Clear();
	try{
		xmlDoc = GetXMLFromWeb(src);
		//pNode = xmlDoc.getElementsByTagName("conquery")[0].getElementsByTagName("entry")[0].getElementsByTagName("title")[0].firstChild.data;//.nodeName
		pNode = xmlDoc.getElementsByTagName("conquery")[0].getElementsByTagName("entry");
		for (i=0; i<pNode.length; i++){
	    repEntryHash._Add(
	      "",
	      ParseNode(pNode[i], "title"),
	      ParseNode(pNode[i], "url"),
	      ParseNode(pNode[i], "method"),
	      ParseNode(pNode[i], "desc"),
	      ""
	    )
		}
	}
	catch(er){alert(er);}
	//initList(repEntryList, repEntryHash);
	initRepTree(repEntryList, repEntryHash);
}

function ParseNode(node, child){
	try{return node.getElementsByTagName(child)[0].firstChild.data;}
	catch(er){return "";}
}

function GetXMLFromWeb(uri) {
	try{
		var xrequest = new XMLHttpRequest();
		xrequest.open("GET",uri,false);
		xrequest.setRequestHeader('Content-type', 'text/xml');
		xrequest.send(null);
	}catch(er){alert(er)}
	return xrequest.responseXML;
}

function CopyFromRep(){
	var RepId = repEntryList.contentView.getItemAtIndex(repEntryList.currentIndex).id;
	EntryHash._Add(
		"",
		repEntryHash._Item(RepId).Title,
		repEntryHash._Item(RepId).URL,
		repEntryHash._Item(RepId).Method,
		repEntryHash._Item(RepId).Desc,
		true
	);
	SavePrefs();
	initList(EntryList, EntryHash);
	alert("''"+repEntryHash._Item(RepId).Title + "'' added to My ConQueries Tab");
}

function onSelectRep(eId){
	if (!eId) eId = repEntryList.contentView.getItemAtIndex(repEntryList.currentIndex).id;
	repEntryDesc.value = repEntryHash._Item(eId).Title + ":\n" +
	repEntryHash._Item(eId).Method + " " + 
	repEntryHash._Item(eId).URL + "\n" +
	repEntryHash._Item(eId).Desc;
}

function initRepTree(list, srcHash){
  while (list.hasChildNodes()) {list.removeChild(list.lastChild)}
  var ondk;
  var onsel;
  var item;
  var node;
  var celldata;
  var entries = srcHash._Items();
	var treecols = document.createElement('treecols');
	var treecol = document.createElement('treecol');
  treecol.setAttribute("label", "test");
  treecol.setAttribute("flex", "1");
  treecol.setAttribute("id", "www");
	treecols.appendChild(treecol);
	list.appendChild(treecols);
	var tch = document.createElement('treechildren');

  for (i=0; i<entries.length; i++){
  	ondk='if (isValidLeftClick(event,"listitem")) CopyEntry(repEntryHash, '+entries[i].eId+', EntryHash, EntryList);';

    item = document.createElement('treeitem');
    item.setAttribute('id', entries[i].eId);
    row = document.createElement('treerow');

    row.setAttribute('id', entries[i].eId);
    row.setAttribute('ondblclick', ondk);
		
    celldata = document.createElement('treecell');
    celldata.setAttribute('label', entries[i].Title);
    celldata.setAttribute('onselect', onsel);
    row.appendChild(celldata);
    
    //item.setAttribute('onselect', 'alert("here");');
    //if (isValidLeftClick(event,"listitem")) 
    item.appendChild(row);
    tch.appendChild(item);
    //list.insertBefore(item, prevItem);
  }
  list.appendChild(tch);
}

function GetMycroftDir(){
	var gDirServiceProp = Components.classes["@mozilla.org/file/directory_service;1"].getService(Components.interfaces.nsIProperties);
	var gChromeDir      = gDirServiceProp.get("AChrom",Components.interfaces.nsIFile);
	delim = "\\";
	if (gChromeDir.path.substr(0,1)=="/") delim = "/";
	patharr = gChromeDir.path.split(delim);
	patharr[patharr.length-1]="searchplugins";
	return patharr.join(delim);
}
///////// ENDOF SECTION /////////////

function ReadPref(name){
	if (Prefs.prefHasUserValue(name)) {
	var type = Prefs.getPrefType(name);
    if (type & 128) {
      return Prefs.getBoolPref(name);
    }
    else if (type & 32) {
			return Prefs.getCharPref(name);
    }
		else {
			return "";
		}
	}
}

function SavePrefs(){
  Prefs.deleteBranch("Entries.");
  var entries = EntryHash._Items();
  for (e in entries){
    Prefs.setCharPref("Entries."+entries[e].eId+".eId", entries[e].eId);
    Prefs.setCharPref("Entries."+entries[e].eId+".Title", entries[e].Title);
    Prefs.setCharPref("Entries."+entries[e].eId+".URL", entries[e].URL);
    Prefs.setCharPref("Entries."+entries[e].eId+".Method", entries[e].Method);
    Prefs.setCharPref("Entries."+entries[e].eId+".Desc", entries[e].Desc);
    Prefs.setBoolPref("Entries."+entries[e].eId+".Context", entries[e].Context);
	}
}

function CopyEntry(srcHash, item, trgHash, trgList){
	trgHash._Add(
		"",
		srcHash._Item(item).Title,
		srcHash._Item(item).URL,
		srcHash._Item(item).Method,
		srcHash._Item(item).Desc,
		true
	);
	SavePrefs();
	initList(trgList, trgHash);
	alert(srcHash._Item(item).Title + " copied");
}

function rmEntry()
{
  if (!EntryList.selectedItem) return;
  EntryHash._Rm(EntryList.selectedItem.getAttribute('value'));
  SavePrefs();
  initList(EntryList, EntryHash);
}

//function onSelect(trgHash, trgDesc, item){
//	trgDesc.value = trgHash._Item(item).Title + ":\n" +
//	trgHash._Item(item).Method + " " + 
//	trgHash._Item(item).URL + "\n" +
//	trgHash._Item(item).Desc;
//}

function onSelect(){
	eId = EntryList.selectedItem.getAttribute('value');
	EntryDesc.value = EntryHash._Item(eId).Title + ":\n" +
	EntryHash._Item(eId).Method + " " + 
	EntryHash._Item(eId).URL + "\n" +
	EntryHash._Item(eId).Desc;
}

function UpdateStatus(check){
  EntryHash[check.id].Context = check.checked;
	SavePrefs();
}

function ExportMycroft(){
	//if (!item) item=EntryList.selectedItem.getAttribute('value');
	//if (item=="add") item="";
	repEntryHash._Clear();
	window.openDialog("chrome://conquery/content/mcparser.xul","_blank",
	"modal,resizable=yes");
}

function AddUpdate(item){
	if (!item) item=EntryList.selectedItem.getAttribute('value');
	if (item=="add") item="";
	window.openDialog("chrome://conquery/content/addupdate.xul","_blank",
	"modal,resizable=yes", item);
	SavePrefs();
	initList(EntryList, EntryHash);
}

function ExecQuery(id){
  window.opener.top.ConfigLastWill = EntryList.selectedItem.getAttribute('value');
  window.close();
}

function isValidLeftClick(aEvent, aName)
{
  // && aEvent.originalTarget.localName == aName
  return (aEvent.button == 0);
}

//function onReturnHit(Event)
//{
//  var focusedElement = document.commandDispatcher.focusedElement;
//
//  if (!focusedElement ||
//    (aEvent.keyCode != aEvent.DOM_VK_ENTER &&
//    aEvent.keyCode != aEvent.DOM_VK_RETURN)) return;
//
//  aEvent.preventBubble();
//  if (focusedElement == gURIBox.inputField)
//    gAddButton.doCommand();
//}
//
